package net.sf.buildbox.maven.contentcheck;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on contentcheck-maven-plugin.<br/> Call <pre>  mvn contentcheck:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Mon Feb 21 23:51:55 GMT+01:00 2011
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.6)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "net.sf.buildbox.maven:contentcheck-maven-plugin:1.0.2", 0 );
        append( sb, "", 0 );

        append( sb, "Maven Content Check Plugin", 0 );
        append( sb, "BuildBox is set of tools and plugins based on Maven 2, helping java developers with various build types and with the build process itself.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 4 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "check".equals( goal ) )
        {
            append( sb, "contentcheck:check", 0 );
            append( sb, "This MOJO checks an archive content according to an authoritative source. This authoritative source defines set of allowed files in the archive.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive (Default: ${project.build.directory}/${project.build.finalName}.${project.packaging})", 2 );
                append( sb, "The archive file to be checked", 3 );
                append( sb, "", 0 );

                append( sb, "checkFilesPattern (Default: **/*.jar)", 2 );
                append( sb, "An Ant like file pattern. If this roperty is present only files matching that pattern are checked. Otherwise all JAR files are checked.", 3 );
                append( sb, "", 0 );

                append( sb, "contentListing (Default: src/main/content.txt)", 2 );
                append( sb, "The file with list of expected files. Each line in that file represents one pathname entry. Empty lines and comments (starting with \'#\') are ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "failOnMissing (Default: false)", 2 );
                append( sb, "If true, stops the build when there is any file missing.", 3 );
                append( sb, "", 0 );

                append( sb, "failOnUnexpected (Default: true)", 2 );
                append( sb, "If true, stops the build when there is any unexpected file.", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreVendorArchives (Default: false)", 2 );
                append( sb, "If true, doesn\'t check vendor JAR files. A vendor JAR file is determined by a value (vendorId) in its manifest key (manifestVendorEntry).", 3 );
                append( sb, "", 0 );

                append( sb, "manifestVendorEntry (Default: Implementation-Vendor-Id)", 2 );
                append( sb, "The name of manifest entry that holds vendor\'s identification", 3 );
                append( sb, "", 0 );

                append( sb, "msgMissing (Default: File is expected but not found: %s)", 2 );
                append( sb, "Message used to report missing entry - uses the Formatter syntax to embed entry name.", 3 );
                append( sb, "", 0 );

                append( sb, "msgUnexpected (Default: Found unexpected file: %s)", 2 );
                append( sb, "Message used to report unexpected entry - uses the Formatter syntax to embed entry name.", 3 );
                append( sb, "", 0 );

                append( sb, "vendorId", 2 );
                append( sb, "The vendor identification. This value is used for JAR\'s manifest checking when ignoreVendorArchives is turned on.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generate".equals( goal ) )
        {
            append( sb, "contentcheck:generate", 0 );
            append( sb, "MOJO for content listing generation from a given archive. This MOJO takes getArchive() and generates archive content to getContentListing().The MOJO generates to the output only entities that matches criteria defined by getCheckFilesPattern() and isIgnoreVendorArchives().", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive (Default: ${project.build.directory}/${project.build.finalName}.${project.packaging})", 2 );
                append( sb, "The archive file to be checked", 3 );
                append( sb, "", 0 );

                append( sb, "checkFilesPattern (Default: **/*.jar)", 2 );
                append( sb, "An Ant like file pattern. If this roperty is present only files matching that pattern are checked. Otherwise all JAR files are checked.", 3 );
                append( sb, "", 0 );

                append( sb, "contentListing (Default: src/main/content.txt)", 2 );
                append( sb, "The file with list of expected files. Each line in that file represents one pathname entry. Empty lines and comments (starting with \'#\') are ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreVendorArchives (Default: false)", 2 );
                append( sb, "If true, doesn\'t check vendor JAR files. A vendor JAR file is determined by a value (vendorId) in its manifest key (manifestVendorEntry).", 3 );
                append( sb, "", 0 );

                append( sb, "manifestVendorEntry (Default: Implementation-Vendor-Id)", 2 );
                append( sb, "The name of manifest entry that holds vendor\'s identification", 3 );
                append( sb, "", 0 );

                append( sb, "overwriteExistingListing (Default: false)", 2 );
                append( sb, "This parameter allows overwriting existing listing file.", 3 );
                append( sb, "", 0 );

                append( sb, "vendorId", 2 );
                append( sb, "The vendor identification. This value is used for JAR\'s manifest checking when ignoreVendorArchives is turned on.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "contentcheck:help", 0 );
            append( sb, "Display help information on contentcheck-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0contentcheck:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "show-licenses".equals( goal ) )
        {
            append( sb, "contentcheck:show-licenses", 0 );
            append( sb, "This MOJO shows license information for an archive entries. Artifact resolving and the rest of Maven repo magic taken from Maven Project Info Reports Plugin. The MOJO shows license information only for entities that matches criteria defined by getCheckFilesPattern() and isIgnoreVendorArchives().\nThe MOJO\'s output is printed by default to console log and also to CSV file ${project.build.directory}/licenses.csv.\n\nLicense information is gathered from dependency\'s POM, but a project may define additional mapping between files in a project archive and licenses. This mapping file is src/main/license.mapping.json and its structure is JSON.\n\nAdditional license information\n{\n\'licenses\':\u00a0[\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0{\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'name\'\u00a0:\u00a0\'License\u00a0name\',\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'url\'\u00a0\u00a0:\u00a0\'License\u00a0text\u00a0URL\',\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'files\':\u00a0[\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'file\u00a0name\'\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0]\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0}\n\u00a0]\n}\n\n\nExample\n{\n\'licenses\':\u00a0[\n\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0{\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'name\'\u00a0\u00a0:\u00a0\'The\u00a0LGPL\u00a0license\u00a02.1\',\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'url\'\u00a0\u00a0\u00a0:\u00a0\'http://www.gnu.org/licenses/lgpl-2.1.html\',\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'files\'\u00a0:\u00a0[\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'aspectwerkz-nodeps-jdk5-2.2.1.jar\'\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0]\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0},\n\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0{\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'name\'\u00a0\u00a0:\u00a0\'The\u00a0public\u00a0domain\',\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'url\'\u00a0\u00a0\u00a0:\u00a0\'http://creativecommons.org/licenses/publicdomain/\',\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'files\'\u00a0:\u00a0[\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'jsr166x-1.0.jar\',\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\'xyz.jar\'\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0]\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0}\n\u00a0\u00a0]\n}\n\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive (Default: ${project.build.directory}/${project.build.finalName}.${project.packaging})", 2 );
                append( sb, "The archive file to be checked", 3 );
                append( sb, "", 0 );

                append( sb, "checkFilesPattern (Default: **/*.jar)", 2 );
                append( sb, "An Ant like file pattern. If this roperty is present only files matching that pattern are checked. Otherwise all JAR files are checked.", 3 );
                append( sb, "", 0 );

                append( sb, "contentListing (Default: src/main/content.txt)", 2 );
                append( sb, "The file with list of expected files. Each line in that file represents one pathname entry. Empty lines and comments (starting with \'#\') are ignored.", 3 );
                append( sb, "", 0 );

                append( sb, "csvOutput (Default: true)", 2 );
                append( sb, "If true print the result of check to a CSV file in project build directory. See csvOutputFile", 3 );
                append( sb, "", 0 );

                append( sb, "csvOutputFile (Default: ${project.build.directory}/licenses.csv)", 2 );
                append( sb, "The CSV output file that is used when csvOutput is turned on.", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreVendorArchives (Default: false)", 2 );
                append( sb, "If true, doesn\'t check vendor JAR files. A vendor JAR file is determined by a value (vendorId) in its manifest key (manifestVendorEntry).", 3 );
                append( sb, "", 0 );

                append( sb, "licenseMappingFile (Default: src/main/license.mapping.json)", 2 );
                append( sb, "The license mapping file. This file may define additional license information for JARs that are not recognized.", 3 );
                append( sb, "", 0 );

                append( sb, "manifestVendorEntry (Default: Implementation-Vendor-Id)", 2 );
                append( sb, "The name of manifest entry that holds vendor\'s identification", 3 );
                append( sb, "", 0 );

                append( sb, "vendorId", 2 );
                append( sb, "The vendor identification. This value is used for JAR\'s manifest checking when ignoreVendorArchives is turned on.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
